#!/usr/bin/perl -w

##############################
# movementgenerator          #
# (c) 2003                   # 
# Author:Peter Liscovius     #
#                            #
# This software is under GPL #
##############################

use strict;

# This tool generates some movementfiles in directory movement/ using 'setdest' of NS-2.

###########################################################
# configuration

#autodetection of setdest
my $setdest=`which ns`;
#$setdest=~ s/bin\/ns/ns-2.1b9\/indep-utils\/cmu-scen-gen\/setdest\/setdest/;
$setdest=~ s/bin\/ns/ns-2.26\/indep-utils\/cmu-scen-gen\/setdest\/setdest/;

chop($setdest);
# comment: setdest uses 250 m as ideal range for calculating routes.

my $simtime=50.0;    # in sec 
my @nn=qw(10);        # list of nodes in simulation
my $x=1250;           # in meter
my $y=800;            # in meter
my @maxspeed=qw(5);   # maximum speed in meter/sec
my $runs=1;           # how many movements for identical parameters we generate 
###########################################################

print "setdest = ".$setdest."\n";
if (not -x "$setdest") {die("$setdest is not executable. Is it there and executable?\n");}

my $pwd=`pwd`;
chop($pwd);
if (not -w "$pwd/movement") {
	#die("Couldn't write to directory movement/ . Create and make it writeable. (chmod 755 movement)\n");
	mkdir("movement",0755);
}

foreach my $nn (@nn) {
	foreach my $maxspeed (@maxspeed) {
		for (my $movementseed=1;$movementseed <= $runs;$movementseed++) {
	
			my $movementFile=$pwd."/movement/movement-n".$nn."-x".$x."-y".$y."-t".$simtime."-s".$maxspeed."-".$movementseed.".txt";
			print "movementFile=".$movementFile."\n";

			my $status= system("$setdest -n $nn -p 5 -s $maxspeed -t $simtime -x $x -y $y >$movementFile"); 
			if ($status !=0) { die("generation of movement failed .. exit movement generation perlscript.\n");}
		}
	}
}
