#!/usr/bin/perl

use Tk;
use Tk::DialogBox;
use Tk::NoteBook;
use Tk::LabEntry;

##########################################################
# samplesplot
#
# takes a tracefile and a 2 files with measured samples of a 
# wireless node containing samples of 2 other neighbornodes.
# and draw vertical lines in every new send/recv RouteRequest event
##########################################################

#config, insert wanted filenames 
#in
$dir="out";
$tracefile=$dir."/tracefile.tr";
#the node 
$myself=2;

#Todo: automatic selection of all neighbors during simulation- problem: not enough good colors in plotmtv
#neighbors
$neighborA=3;
$neighborB=5;
#$neighborC=5;
#out
$sampleoutfile=$dir."/sampleout$myself.mtv";

use vars qw($top);

$top = MainWindow->new;

my $pb = $top->Button(-text => "New Plot", -command => \&dialog);
$pb->pack;
MainLoop;

sub dialog{

$f = $top->DialogBox(	-title => "Select Nodes", 
			-buttons => ["OK", "Cancel"]);
my $n = $f->add('NoteBook', -ipadx => 6, -ipady => 6);
$n->LabEntry(-label => "Node:",
	-labelPack => [-side => "left", 
	-anchor => "w"],
	-width => 3, 
	-textvariable => \$myself)->pack(-side => "top", -anchor => "nw");
$n->LabEntry(-label => "Neighbor:",
	-labelPack => [-side => "left", 
	-anchor => "w"],
	-width => 3, 
	-textvariable => \$neighborA)->pack(-side => "top", -anchor => "nw");
$n->LabEntry(-label => "Neighbor:",
	-labelPack => [-side => "left", 
	-anchor => "w"],
	-width => 3, 
	-textvariable => \$neighborB)->pack(-side => "top", -anchor => "nw");	
$n->LabEntry(-label => "Directory:",
	-labelPack => [-side => "left", 
	-anchor => "w"],
	-width => 20, 
	-textvariable => \$dir)->pack(-side => "top", -anchor => "nw");						
$n->pack(-expand => "yes",
	-fill => "both",
	-padx => 5, 
	-pady => 5,
	-side => "top");

my $result = $f->Show;
if ($result =~ /OK/) 
{ 
	print "Node = $myself, NeighborA=$neighborA , NeighborB=$neighborB, NeighborC=$neighborC\n";
	$sampleoutfile=$dir."/sampleout$myself.mtv";
	$samplefile1=$dir."/samples-".$myself."-".$neighborA.".dat";
	$samplefile2=$dir."/samples-".$myself."-".$neighborB.".dat";
	$tracefile=$dir."/tracefile.tr";
  	&doit;
  	&show;
}

}


sub doit {

#find send or receive packets in tracefile on node 2 from analyzed neighbors
open(TRACE,"$tracefile") or die("Couldn't open file $tracefile.");
@trace=<TRACE>;
close TRACE;
$plot1header="\$ DATA=CURVE2D\n% toplabel   = \"NODE $myself\"\n";
$plot1header=$plot1header."% grid ON\n% ymin=0.0000000001\n% ymax=0.0000001\n";
$plot1header=$plot1header."% xlabel=\"Time (sec)\" ylabel=\"Signalpower (Watt)\" ylog=TRUE\n";
$plot1header=$plot1header."% linetype=1 linecolor=4 markertype=10 markercolor=6\n% linelabel  =\"Neighbor $neighborA\"\n";

$plot2header="\$ DATA=CURVE2D\n";
$plot2header=$plot2header."% linetype=1 linecolor=5 markertype=11 markercolor=5\n% linelabel  =\"Neighbor $neighborB\"\n";
$replycounter=0;
$requestcounter=0;
foreach $traceline (@trace){
  	if ($traceline=~ /\-Ni $myself/ && $traceline=~ /\-Nl RTR/) 
	{	
		if ($traceline=~ /\-It AODV/ && $traceline=~ /REQUEST/ && $traceline=~ /^s/)
		{
			#get time of simulation from tracefile-line
			#hopeful always the right value in the line
			my @line=split(/ /,$traceline);
			my $simtime=$line[2];
			my $col=0;
			my $destination=-1;
			foreach (@line) {
				chomp();
				print "$_\n";
				#find the destination field in RREQ packet
				if ($_ eq  "-Pd") { $destination = $line[$col+1]}
				$col++;	
			}
			my $linecolor=10;
			print $traceline."\n";
			$plotlines=$plotlines.'@ line x1='.$simtime.' y1=0 x2='.$simtime.' y2=1000 linecolor='.$linecolor."\n"; 
			$plotlines=$plotlines.'@ arrow x1='.($simtime-0.2).' y1='.(0.000000001+$requestcounter*0.0000000001).' x2='.$simtime.' y2='.(0.000000001+$requestcounter*0.0000000001).' linecolor='.$linecolor.' linelabel="send RREQ '.$destination.'"'."\n";
  		}
		elsif ($traceline=~ /\-It AODV/ && $traceline=~ /ERROR/ && $traceline=~ /^s/)
		{
			#get time of simulation from tracefile-line
			#hopeful always the right value in the line
			my @line=split(/ /,$traceline);
			my $simtime=$line[2];
			my $linecolor=4;
			print $traceline."\n";
			$plotlines=$plotlines.'@ line x1='.$simtime.' y1=0 x2='.$simtime.' y2=1000 linecolor='.$linecolor."\n"; 
  			$plotlines=$plotlines.'@ arrow x1='.($simtime-0.2).' y1=0.000000001 x2='.$simtime.' y2=0.000000001 linecolor='.$linecolor.' linelabel="send ERROR"'."\n";
			$requestcounter++;
		}
		elsif ($traceline=~ /REPLY/ && $traceline=~ /^r/) 
		{
			my @line=split(/ /,$traceline);
			my $simtime=$line[2];
			#search neighborID
			my $col=0;
			my $neighbor=0;
			my $destination=-1;
			foreach (@line) {
				chomp();
				print "$_\n";
				#MAC Source
				if ($_ eq  "-Ms") { $neighbor = $line[$col+1]}
				if ($_ eq  "-Is") { $destination = $line[$col+1]} #$destination of RREQ = -Is sender of Reply !!!
				$col++;	
			}
			my $linecolor=0;
			print $traceline."\n";
			$plotlines=$plotlines.'@ line x1='.$simtime.' y1=0 x2='.$simtime.' y2=1000 linecolor='.$linecolor."\n"; 
			$plotlines=$plotlines.'@ arrow x1='.($simtime-0.1).' y1='.(0.0000000015+$replycounter*0.0000000005).' x2='.$simtime.' y2='.(0.0000000015+$replycounter*0.0000000005).' linecolor='.$linecolor.' linelabel="receive REPLY '.$neighbor.' ('.$destination.')"'."\n";
			$replycounter++;
		}
	}
}

#1.559e-11 is the standard Carrier Sense of Wireless Nodes in NS-2. 
$plotlines=$plotlines.'@ line x1=5 y1=1.559e-11 x2=1000 y2=1.559e-11 linecolor=7 linelabel="Carrier? Sense? Threshold"'."\n";
#3.652e-10 is the standard Receive Threshold of Wireless Nodes in NS-2.
$plotlines=$plotlines.'@ line x1=5 y1=3.652e-10 x2=1000 y2=3.652e-10 linecolor=7 linelabel="Receive Threshold"'."\n";
$plotlines=$plotlines."\$ END";
#
open(SAMPLES1,"$samplefile1") or die("Couldn't open file $samplefile1.");
open(SAMPLES2,"$samplefile2") or die("Couldn't open file $samplefile2.");

@samples1=<SAMPLES1>;
@samples2=<SAMPLES2>;

#concatenate lines and write out plotmtv-ready file 
@plot=($plot1header,@samples1,$plot2header,@samples2,$plotlines);

open(TOPLOTMTVFILE,">$sampleoutfile") or die("Couldn't open file for writing $sampleoutfile.\n");
print TOPLOTMTVFILE @plot;
close(TOPLOTMTVFILE);

#print "\nOK.\nLook at $sampleoutfile and plot it with plotmtv.\nSample plotcommand: plotmtv -plotall -l -colorps $sampleoutfile\n\n";

}

sub show{
	$status=`plotmtv -bg '#FFFFFF' -fg '#000000' -plotall -l -colorps $sampleoutfile`; 
}
